--- /dev/null
+#
+# Copyright (C) 2006-2012 OpenWrt.org
+#
+# This is free software, licensed under the GNU General Public License v2.
+# See /LICENSE for more information.
+#
+
+include $(TOPDIR)/rules.mk
+
+PKG_NAME:=dhcp
+PKG_VERSION:=4.2.4
+PKG_RELEASE:=1
+
+PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.gz
+PKG_SOURCE_URL:=ftp://ftp.isc.org/isc/dhcp/$(PKG_VERSION)
+PKG_MD5SUM:=c244cefe663d43100af757d8ff625a1f
+
+PKG_FIXUP:=autoreconf
+PKG_BUILD_PARALLEL:=1
+
+include $(INCLUDE_DIR)/package.mk
+
+define Package/dhcp/Default
+ SECTION:=net
+ CATEGORY:=Network
+ SUBMENU:=IP Addresses and Names
+ TITLE:=ISC's DHCP
+ URL:=https://www.isc.org/software/dhcp
+endef
+
+define Package/dhcp-relay
+ $(call Package/dhcp/Default)
+ TITLE+= relay
+endef
+
+define Package/dhcp-relay/description
+ provides a means for relaying DHCP and BOOTP requests from a subnet to which
+ no DHCP server is directly connected to one or more DHCP servers on other
+ subnets.
+endef
+
+define Package/dhcp-client
+ $(call Package/dhcp/Default)
+ TITLE+= client
+endef
+
+define Package/dhcp-client/description
+ provides a means for configuring one or more network interfaces using the
+ Dynamic Host Configuration Protocol, BOOTP protocol, or if these protocols
+ fail, by statically assigning an address.
+endef
+
+define Package/dhcp-server
+ $(call Package/dhcp/Default)
+ TITLE+= server
+endef
+
+define Package/dhcp-server/description
+ implements the Dynamic Host Configuration Protocol (DHCP) and the Internet
+ Bootstrap Protocol (BOOTP).
+endef
+
+define Package/dhcp-omshell
+ $(call Package/dhcp/Default)
+ DEPENDS:= +dhcp-server
+ TITLE+= omshell
+endef
+
+define Package/dhcp-omshell/description
+ provides an interactive way to connect to, query, and possibly change, the ISC
+ DHCP Server's state via OMAPI, the Object Management API.
+endef
+
+CONFIGURE_ARGS += \
+ --disable-tracing \
+ --enable-paranoia \
+ --disable-dependency-tracking \
+ ac_cv_file__dev_random=yes
+
+ifeq ($(CONFIG_DHCP4_ENABLE_IPV6),y)
+ CONFIGURE_ARGS += --enable-dhcpv6
+else
+ CONFIGURE_ARGS += --disable-dhcpv6
+endif
+
+define Build/Compile
+ $(MAKE) -C $(PKG_BUILD_DIR) \
+ DESTDIR="$(PKG_INSTALL_DIR)" \
+ BUILD_CC="$(HOSTCC_NOCACHE)" \
+ host_alias="$(GNU_TARGET_NAME)" \
+ target_alias="$(GNU_TARGET_NAME)" \
+ build_alias="$(GNU_HOST_NAME)" \
+ ac_cv_file__dev_random=yes \
+ all install-exec
+endef
+
+define Package/dhcp-relay/install
+ $(INSTALL_DIR) $(1)/usr/sbin
+ $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/dhcrelay $(1)/usr/sbin/
+endef
+
+define Package/dhcp-server/install
+ $(INSTALL_DIR) $(1)/usr/sbin $(1)/etc/init.d
+ $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/dhcpd $(1)/usr/sbin/
+ $(INSTALL_BIN) ./files/dhcpd.init $(1)/etc/init.d/dhcpd
+ $(INSTALL_BIN) ./files/dhcpd.conf $(1)/etc
+ifeq ($(CONFIG_DHCP4_ENABLE_IPV6),y)
+ $(INSTALL_BIN) ./files/dhcpd6.init $(1)/etc/init.d/dhcpd6
+ $(INSTALL_BIN) ./files/dhcpd6.conf $(1)/etc
+endif
+endef
+
+define Package/dhcp-client/install
+ $(INSTALL_DIR) $(1)/usr/sbin $(1)/etc/init.d
+ $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/dhclient $(1)/usr/sbin/
+ $(INSTALL_BIN) ./files/dhclient-script $(1)/usr/sbin/
+ $(INSTALL_BIN) ./files/dhclient.init $(1)/etc/init.d/dhclient
+ifeq ($(CONFIG_DHCP4_ENABLE_IPV6),y)
+ $(INSTALL_BIN) ./files/dhclient6.init $(1)/etc/init.d/dhclient6
+ $(INSTALL_BIN) ./files/dhclient6.conf $(1)/etc
+endif
+endef
+
+define Package/dhcp-omshell/install
+ $(INSTALL_DIR) $(1)/usr/bin
+ $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/omshell $(1)/usr/bin/
+endef
+
+$(eval $(call BuildPackage,dhcp-relay))
+$(eval $(call BuildPackage,dhcp-server))
+$(eval $(call BuildPackage,dhcp-client))
+$(eval $(call BuildPackage,dhcp-omshell))
--- /dev/null
+#!/bin/sh
+
+make_resolv_conf() {
+ if [ x"$new_domain_name_servers" != x ]; then
+ cat /dev/null > /etc/resolv.conf.dhclient
+ chmod 644 /etc/resolv.conf.dhclient
+ if [ x"$new_domain_search" != x ]; then
+ echo search $new_domain_search >> /etc/resolv.conf.dhclient
+ elif [ x"$new_domain_name" != x ]; then
+ # Note that the DHCP 'Domain Name Option' is really just a domain
+ # name, and that this practice of using the domain name option as
+ # a search path is both nonstandard and deprecated.
+ echo search $new_domain_name >> /etc/resolv.conf.dhclient
+ fi
+ for nameserver in $new_domain_name_servers; do
+ echo nameserver $nameserver >>/etc/resolv.conf.dhclient
+ done
+
+ elif [ "x${new_dhcp6_name_servers}" != x ] ; then
+ cat /dev/null > /etc/resolv.conf.dhclient6
+ chmod 644 /etc/resolv.conf.dhclient6
+
+ if [ "x${new_dhcp6_domain_search}" != x ] ; then
+ echo search ${new_dhcp6_domain_search} >> /etc/resolv.conf.dhclient6
+ fi
+ for nameserver in ${new_dhcp6_name_servers} ; do
+ echo nameserver ${nameserver} >> /etc/resolv.conf.dhclient6
+ done
+ fi
+
+ # if both v4 and v6 clients are running, concatenate results
+ cat /etc/resolv.conf.* > /etc/resolv.conf
+}
+
+# Must be used on exit. Invokes the local dhcp client exit hooks, if any.
+exit_with_hooks() {
+ exit_status=$1
+ if [ -f /etc/dhclient-exit-hooks ]; then
+ . /etc/dhclient-exit-hooks
+ fi
+# probably should do something with exit status of the local script
+ exit $exit_status
+}
+
+# Invoke the local dhcp client enter hooks, if they exist.
+if [ -f /etc/dhclient-enter-hooks ]; then
+ exit_status=0
+ . /etc/dhclient-enter-hooks
+ # allow the local script to abort processing of this state
+ # local script must set exit_status variable to nonzero.
+ if [ $exit_status -ne 0 ]; then
+ exit $exit_status
+ fi
+fi
+
+###
+### DHCPv4 Handlers
+###
+
+if [ x$new_broadcast_address != x ]; then
+ new_broadcast_arg="broadcast $new_broadcast_address"
+fi
+if [ x$new_subnet_mask != x ]; then
+ new_subnet_arg="netmask $new_subnet_mask"
+fi
+if [ x$alias_subnet_mask != x ]; then
+ alias_subnet_arg="netmask $alias_subnet_mask"
+fi
+
+if [ x$reason = xMEDIUM ]; then
+ # Linux doesn't do mediums (ok, ok, media).
+ exit_with_hooks 0
+fi
+
+if [ x$reason = xPREINIT ]; then
+ if [ x$alias_ip_address != x ]; then
+ # Bring down alias interface. Its routes will disappear too.
+ ifconfig $interface:0- 0.0.0.0
+ fi
+ ifconfig $interface 0.0.0.0 up
+
+ # We need to give the kernel some time to get the interface up.
+ sleep 1
+
+ exit_with_hooks 0
+fi
+
+if [ x$reason = xARPCHECK ] || [ x$reason = xARPSEND ]; then
+ exit_with_hooks 0
+fi
+
+if [ x$reason = xBOUND ] || [ x$reason = xRENEW ] || \
+ [ x$reason = xREBIND ] || [ x$reason = xREBOOT ]; then
+ current_hostname=`hostname`
+ if [ x$current_hostname = x ] || \
+ [ x$current_hostname = x$old_host_name ]; then
+ if [ x$current_hostname = x ] || \
+ [ x$new_host_name != x$old_host_name ]; then
+ hostname $new_host_name
+ fi
+ fi
+
+ if [ x$old_ip_address != x ] && [ x$alias_ip_address != x ] && \
+ [ x$alias_ip_address != x$old_ip_address ]; then
+ # Possible new alias. Remove old alias.
+ ifconfig $interface:0- 0.0.0.0
+ fi
+ if [ x$old_ip_address != x ] && [ x$old_ip_address != x$new_ip_address ]; then
+ # IP address changed. Bringing down the interface will delete all routes,
+ # and clear the ARP cache.
+ ifconfig $interface 0.0.0.0 down
+
+ fi
+ if [ x$old_ip_address = x ] || [ x$old_ip_address != x$new_ip_address ] || \
+ [ x$reason = xBOUND ] || [ x$reason = xREBOOT ]; then
+
+ ifconfig $interface $new_ip_address $new_subnet_arg \
+ $new_broadcast_arg
+ for router in $new_routers; do
+ if [ "x$new_subnet_mask" = "x255.255.255.255" ] ; then
+ route add -host $router dev $interface
+ fi
+ route add default gw $router
+ done
+ fi
+ if [ x$new_ip_address != x$alias_ip_address ] && [ x$alias_ip_address != x ];
+ then
+ ifconfig $interface:0- 0.0.0.0
+ ifconfig $interface:0 $alias_ip_address $alias_subnet_arg
+ route add -host $alias_ip_address $interface:0
+ fi
+ make_resolv_conf
+ exit_with_hooks 0
+fi
+
+if [ x$reason = xEXPIRE ] || [ x$reason = xFAIL ] || [ x$reason = xRELEASE ] \
+ || [ x$reason = xSTOP ]; then
+ if [ x$alias_ip_address != x ]; then
+ # Turn off alias interface.
+ ifconfig $interface:0- 0.0.0.0
+ fi
+ if [ x$old_ip_address != x ]; then
+ # Shut down interface, which will delete routes and clear arp cache.
+ ifconfig $interface 0.0.0.0 down
+ fi
+ if [ x$alias_ip_address != x ]; then
+ ifconfig $interface:0 $alias_ip_address $alias_subnet_arg
+ route add -host $alias_ip_address $interface:0
+ fi
+
+ # remove v4 dns configuration for this interface
+ rm /etc/resolv.conf.dhclient
+ cat /etc/resolv.conf.* > /etc/resolv.conf
+
+ exit_with_hooks 0
+fi
+
+if [ x$reason = xTIMEOUT ]; then
+ if [ x$alias_ip_address != x ]; then
+ ifconfig $interface:0- 0.0.0.0
+ fi
+ ifconfig $interface $new_ip_address $new_subnet_arg \
+ $new_broadcast_arg
+ set $new_routers
+ if ping -q -c 1 $1; then
+ if [ x$new_ip_address != x$alias_ip_address ] && \
+ [ x$alias_ip_address != x ]; then
+ ifconfig $interface:0 $alias_ip_address $alias_subnet_arg
+ route add -host $alias_ip_address dev $interface:0
+ fi
+ for router in $new_routers; do
+ if [ "x$new_subnet_mask" = "x255.255.255.255" ] ; then
+ route add -host $router dev $interface
+ fi
+ route add default gw $router
+ done
+ make_resolv_conf
+ exit_with_hooks 0
+ fi
+ ifconfig $interface 0.0.0.0 down
+ exit_with_hooks 1
+fi
+
+###
+### DHCPv6 Handlers
+###
+
+if [ x$reason = xPREINIT6 ]; then
+ # Ensure interface is up.
+ ifconfig ${interface} up
+
+ # Remove any stale addresses from aborted clients.
+ ip -f inet6 addr flush dev ${interface} scope global
+
+ exit_with_hooks 0
+fi
+
+if [ x${old_ip6_prefix} != x ] || [ x${new_ip6_prefix} != x ] ; then
+ echo Prefix ${reason} old=${old_ip6_prefix} new=${new_ip6_prefix}
+
+ exit_with_hooks 0
+fi
+
+if [ x$reason = xBOUND6 ]; then
+ if [ x${new_ip6_address} = x ] || [ x${new_ip6_prefixlen} = x ] ; then
+ exit_with_hooks 2;
+ fi
+
+ ifconfig ${interface} add ${new_ip6_address}/${new_ip6_prefixlen}
+
+ # Check for nameserver options.
+ make_resolv_conf
+
+### <<
+ # Set up softwire tunnel
+ if [ x${new_dhcp6_softwire} != x ] ; then
+ /etc/init.d/dhclient stop
+ ifconfig ${interface} 0.0.0.0
+ ip -6 tunnel add tun0 mode ipip6 \
+ remote ${new_dhcp6_softwire} \
+ local ${new_ip6_address} \
+ dev ${interface} encaplimit none
+ ip link set tun0 up
+ ip route add default dev tun0
+ fi
+### >>
+
+ exit_with_hooks 0
+fi
+
+if [ x$reason = xRENEW6 ] || [ x$reason = xREBIND6 ]; then
+ if [ x${new_ip6_address} = x ] || [ x${new_ip6_prefixlen} = x ] ; then
+ exit_with_hooks 2;
+ fi
+
+ ifconfig ${interface} add ${new_ip6_address}/${new_ip6_prefixlen}
+
+ # Make sure nothing has moved around on us.
+
+ # Nameservers/domains/etc.
+ if [ "x${new_dhcp6_name_servers}" != "x${old_dhcp6_name_servers}" ] ||
+ [ "x${new_dhcp6_domain_search}" != "x${old_dhcp6_domain_search}" ] ; then
+ make_resolv_conf
+ fi
+
+ exit_with_hooks 0
+fi
+
+if [ x$reason = xDEPREF6 ]; then
+ if [ x${new_ip6_address} = x ] ; then
+ exit_with_hooks 2;
+ fi
+
+ # Busybox ifconfig has no way to communicate this to the kernel, so ignore it
+
+ exit_with_hooks 0
+fi
+
+if [ x$reason = xEXPIRE6 -o x$reason = xRELEASE6 -o x$reason = xSTOP6 ]; then
+ if [ x${old_ip6_address} = x ] || [ x${old_ip6_prefixlen} = x ] ; then
+ exit_with_hooks 2;
+ fi
+
+ ifconfig ${interface} del ${old_ip6_address}/${old_ip6_prefixlen}
+
+ # remove v6 dns configuration for this interface
+ rm /etc/resolv.conf.dhclient6
+ cat /etc/resolv.conf.* > /etc/resolv.conf
+
+### <<
+ # Tear down softwire tunnel
+ if [ x${old_dhcp6_softwire} != x ] ; then
+ ip link set tun0 down
+ ip tunnel del tun0
+ fi
+### >>
+
+ exit_with_hooks 0
+fi
+
+exit_with_hooks 0
--- /dev/null
+#!/bin/sh /etc/rc.common
+
+START=60
+
+lease_file=/var/dhclient.leases
+config_file=/etc/dhclient.conf
+pid_file=/var/run/dhclient.pid
+script_file=/usr/sbin/dhclient-script
+
+start() {
+ /usr/sbin/dhclient -q -nw -cf $config_file -lf $lease_file -pf $pid_file -sf $script_file `/sbin/uci get network.wan.ifname`
+
+ if [ $? -ne 0 ]; then
+ return 1
+ fi
+}
+
+stop() {
+ if [ ! -e $pid_file ]; then
+ return 1
+ fi
+
+ kill -9 `cat $pid_file`
+
+ if [ $? -ne 0 ]; then
+ return 1
+ fi
+
+ rm $pid_file
+}
--- /dev/null
+option dhcp6.softwire code 54 = ip6-address;
+also request dhcp6.softwire;
--- /dev/null
+#!/bin/sh /etc/rc.common
+
+START=60
+
+lease_file=/var/dhclient6.leases
+config_file=/etc/dhclient6.conf
+pid_file=/var/run/dhclient6.pid
+script_file=/usr/sbin/dhclient-script
+
+start() {
+ /usr/sbin/dhclient -q -nw -6 -cf $config_file -lf $lease_file -pf $pid_file -sf $script_file `/sbin/uci get network.wan.ifname`
+
+ if [ $? -ne 0 ]; then
+ return 1
+ fi
+}
+
+stop() {
+ if [ ! -e $pid_file ]; then
+ return 1
+ fi
+
+ kill -9 `cat $pid_file`
+
+ if [ $? -ne 0 ]; then
+ return 1
+ fi
+
+ rm $pid_file
+}
--- /dev/null
+# dhcpd.conf
+
+authoritative;
+
+default-lease-time 3600;
+max-lease-time 86400;
+
+option domain-name-servers 192.168.1.1;
+
+subnet 192.168.1.0 netmask 255.255.255.0 {
+ range 192.168.1.10 192.168.1.50;
+ option routers 192.168.1.1;
+}
--- /dev/null
+#!/bin/sh /etc/rc.common
+
+START=65
+
+lease_file=/var/dhcpd.leases
+config_file=/etc/dhcpd.conf
+pid_file=/var/run/dhcpd.pid
+
+start() {
+ if [ ! -e $lease_file ]; then
+ touch $lease_file
+ fi
+
+ /usr/sbin/dhcpd -q -cf $config_file -lf $lease_file -pf $pid_file
+
+ if [ $? -ne 0 ]; then
+ return 1
+ fi
+}
+
+stop() {
+ if [ ! -e $pid_file ]; then
+ return 1
+ fi
+
+ kill -9 `cat $pid_file`
+
+ if [ $? -ne 0 ]; then
+ return 1
+ fi
+
+ rm $pid_file
+}
--- /dev/null
+# dhcpd6.conf
+
+authoritative;
+
+default-lease-time 3600;
+max-lease-time 86400;
+
+# Enable RFC 5007 support
+#allow leasequery;
+
+# Global definitions for name server address(es) and domain search list
+#option dhcp6.name-servers 3ffe:501:ffff:100:200:ff:fe00:3f3e;
+#option dhcp6.domain-search "test.example.com","example.com";
+
+# Set preference to 255 (maximum) in order to avoid waiting for
+# additional servers when there is only one
+#option dhcp6.preference 255;
+
+# Server side command to enable rapid-commit (2 packet exchange)
+#option dhcp6.rapid-commit;
+
+# The delay before information-request refresh
+# (minimum is 10 minutes, maximum one day, default is to not refresh)
+# (set to 6 hours)
+#option dhcp6.info-refresh-time 3600;
+
+subnet6 3ffe:501:ffff:101::/64 {
+ # Use the whole /64 prefix for clients
+ range6 3ffe:501:ffff:101:: /64;
+}
--- /dev/null
+#!/bin/sh /etc/rc.common
+
+START=65
+
+lease_file=/var/dhcpd6.leases
+config_file=/etc/dhcpd6.conf
+pid_file=/var/run/dhcpd6.pid
+
+start() {
+ if [ ! -e $lease_file ]; then
+ touch $lease_file
+ fi
+
+ /usr/sbin/dhcpd -q -6 -cf $config_file -lf $lease_file -pf $pid_file
+
+ if [ $? -ne 0 ]; then
+ return 1
+ fi
+}
+
+stop() {
+ if [ ! -e $pid_file ]; then
+ return 1
+ fi
+
+ kill -9 `cat $pid_file`
+
+ if [ $? -ne 0 ]; then
+ return 1
+ fi
+
+ rm $pid_file
+}
--- /dev/null
+--- a/bind/Makefile
++++ b/bind/Makefile
+@@ -61,9 +61,12 @@ all:
+ echo Bind export libraries already installed ; \
+ else \
+ echo Building BIND Export libraries - this takes some time. ;\
++ (cd ${bindsrcdir}/lib/export/dns ; \
++ echo building gen using ${BUILD_CC} in `pwd` ; \
++ $(MAKE) CC=${BUILD_CC} CFLAGS="-O2" LIBS="" gen) ; \
+ (cd ${bindsrcdir}/lib/export ; \
+ echo building in `pwd` ; \
+- MAKE=${GMAKE} ${GMAKE} > ${binddir}/build.log) ; \
++ $(MAKE) DESTDIR="" install > ${binddir}/build.log) ; \
+ \
+ echo Installing BIND Export libraries to ${binddir}. ; \
+ (cd ${bindsrcdir}/lib/export ; \
+@@ -77,6 +80,7 @@ clean:
+
+ # Include the following so that this Makefile is happy when the parent
+ # tries to use them.
++install-exec:
+
+ distdir:
+
+++ /dev/null
-config DHCP4_ENABLE_IPV6
- bool "Enable IPv6 capabilities (DHCPv6)"
- depends on PACKAGE_kmod-ipv6 && PACKAGE_dhcp4
- default y
- help
- Enables IPv6 features in all built DHCP4 packages
-
+++ /dev/null
-#
-# Copyright (C) 2006-2008 OpenWrt.org
-#
-# This is free software, licensed under the GNU General Public License v2.
-# See /LICENSE for more information.
-#
-# This makefile is loosely based on a version for 4.1.0 that was designed to be OpenWRT friendly.
-#
-# $Id: Makefile 1 2011-12-17 17:42:34Z Olipro $
-
-include $(TOPDIR)/rules.mk
-
-PKG_NAME:=dhcp
-PKG_VERSION:=4.2.3-P1
-PKG_RELEASE:=1
-
-PKG_SOURCE:=$(PKG_NAME)-$(PKG_VERSION).tar.gz
-PKG_SOURCE_URL:=ftp://ftp.isc.org/isc/dhcp/$(PKG_VERSION)
-PKG_MD5SUM:=04599f1557a5cafd10d7745267a68c8b
-
-PKG_FIXUP:=autoreconf
-PKG_BUILD_PARALLEL:=1
-
-include $(INCLUDE_DIR)/package.mk
-
-define Package/dhcp4/Default
- SECTION:=net
- CATEGORY:=Network
- URL:=http://www.isc.org/
-endef
-
-define Package/dhcp4
- $(call Package/dhcp4/Default)
- TITLE:=ISC DHCP-${PKG_VERSION}
-# PKG_HOST_ONLY:=1
- MENU:=1
-endef
-
-define Package/dhcp4/config
- source "$(SOURCE)/Config.in"
-endef
-
-define Package/dhcp4/description
--
- This is the latest available version of the ISC DHCP suite. Generally speaking, you are unlikely
- to have any need of this application; it has a considerably larger filesize than dnsmasq and thus
- you should only be selecting this package because you need features only available in this suite.
-
-endef
-
-define Package/dhcp4-relay
- $(call Package/dhcp4/Default)
- DEPENDS:=@PACKAGE_dhcp4
- TITLE:=ISC DHCP Relay
-endef
-
-define Package/dhcp4-relay/description
-The DHCP relay agent is for relaying DHCP messages between separate network segments.
-
- This is the latest available version of the ISC DHCP suite. Generally speaking, you are unlikely
- to have any need of this application; it has a considerably larger filesize than dnsmasq and thus
- you should only be selecting this package because you need features only available in this suite.
-
-endef
-
-define Package/dhcp4-server
- $(call Package/dhcp4/Default)
- DEPENDS:=@PACKAGE_dhcp4
- TITLE:=ISC DHCP Server
-endef
-
-define Package/dhcp4-server/description
-The ISC DHCP server provides comprehensive DHCP configuration and functionality for network
-hosts that have a complimentary DHCP client running.
-
- This is the latest available version of the ISC DHCP suite. Generally speaking, you are unlikely
- to have any need of this application; it has a considerably larger filesize than dnsmasq and thus
- you should only be selecting this package because you need features only available in this suite.
-
-endef
-
-define Package/dhcp4-client
- $(call Package/dhcp4/Default)
- DEPENDS:=@PACKAGE_dhcp4
- TITLE:=ISC DHCP Client
-endef
-
-define Package/dhcp4-client/description
-The ISC DHCP client receives configuration information from a DHCP server and configures the host
-accordingly.
-
- This is the latest available version of the ISC DHCP suite. Generally speaking, you are unlikely
- to have any need of this application; it has a considerably larger filesize than dnsmasq and thus
- you should only be selecting this package because you need features only available in this suite.
-
-endef
-
-define Package/dhcp4-omshell
- $(call Package/dhcp4/Default)
- DEPENDS:=@PACKAGE_dhcp4
- TITLE:=ISC DHCP OmShell
-endef
-
-define Package/dhcp4-omshell/description
-The ISC OmShell utility enables you to change the configuration of a running DHCP instance
-without having to endure the hassle of manually modifying the configuration file then
-killing and restarting it.
-
- This is the latest available version of the ISC DHCP suite. Generally speaking, you are unlikely
- to have any need of this application; it has a considerably larger filesize than dnsmasq and thus
- you should only be selecting this package because you need features only available in this suite.
-
-endef
-
-CONFIGURE_ARGS += ac_cv_file__dev_random=yes --disable-tracing --enable-paranoia --disable-dependency-tracking
-ifeq ($(CONFIG_DHCP4_ENABLE_IPV6),y)
- CONFIGURE_ARGS += --enable-dhcpv6
-else
- CONFIGURE_ARGS += --disable-dhcpv6
-endif
-
-
-define Build/Compile
- $(MAKE) -C $(PKG_BUILD_DIR) \
- DESTDIR="$(PKG_INSTALL_DIR)" \
- CROSS_COMPILE="$(GNU_TARGET_NAME)" BUILD_CC="$(HOSTCC)" CC="$(TARGET_CC)" host_alias="$(GNU_TARGET_NAME)" target_alias="$(GNU_TARGET_NAME)" build_alias="$(GNU_HOST_NAME)" \
- ac_cv_file__dev_random=yes \
- all install-exec
-endef
-
-define Package/dhcp4/install
-
-endef
-
-define Package/dhcp4-relay/install
- $(INSTALL_DIR) $(1)/usr/sbin
- $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/dhcrelay $(1)/usr/sbin/
-endef
-
-define Package/dhcp4-server/install
- $(INSTALL_DIR) $(1)/usr/sbin
-# $(INSTALL_DIR) $(1)/usr/lib
- $(INSTALL_DIR) $(1)/etc/init.d
- $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/dhcpd $(1)/usr/sbin/
-#Libs appear to be unnecessary
-# $(INSTALL_DATA) $(PKG_INSTALL_DIR)/usr/lib/*.a $(1)/usr/lib
- $(INSTALL_BIN) ./files/dhcpd.init $(1)/etc/init.d/dhcpd
- $(INSTALL_BIN) ./files/dhcpd.conf $(1)/etc
-ifeq ($(CONFIG_DHCP4_ENABLE_IPV6),y)
- $(INSTALL_BIN) ./files/dhcpd6.init $(1)/etc/init.d/dhcpd6
- $(INSTALL_BIN) ./files/dhcpd6.conf $(1)/etc
-endif
-endef
-
-define Package/dhcp4-client/install
- $(INSTALL_DIR) $(1)/usr/sbin
- $(INSTALL_DIR) $(1)/etc/init.d
- $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/sbin/dhclient $(1)/usr/sbin/
- $(INSTALL_BIN) ./files/dhclient-script $(1)/usr/sbin/
- $(INSTALL_BIN) ./files/dhclient.init $(1)/etc/init.d/dhclient
-ifeq ($(CONFIG_DHCP4_ENABLE_IPV6),y)
- $(INSTALL_BIN) ./files/dhclient6.init $(1)/etc/init.d/dhclient6
- $(INSTALL_BIN) ./files/dhclient6.conf $(1)/etc
-endif
-endef
-
-define Package/dhcp4-omshell/install
- $(INSTALL_DIR) $(1)/usr/bin
- $(INSTALL_BIN) $(PKG_INSTALL_DIR)/usr/bin/omshell $(1)/usr/bin/
-endef
-
-$(eval $(call BuildPackage,dhcp4))
-$(eval $(call BuildPackage,dhcp4-relay))
-$(eval $(call BuildPackage,dhcp4-server))
-$(eval $(call BuildPackage,dhcp4-client))
-$(eval $(call BuildPackage,dhcp4-omshell))
+++ /dev/null
-#!/bin/sh
-
-make_resolv_conf() {
- if [ x"$new_domain_name_servers" != x ]; then
- cat /dev/null > /etc/resolv.conf.dhclient
- chmod 644 /etc/resolv.conf.dhclient
- if [ x"$new_domain_search" != x ]; then
- echo search $new_domain_search >> /etc/resolv.conf.dhclient
- elif [ x"$new_domain_name" != x ]; then
- # Note that the DHCP 'Domain Name Option' is really just a domain
- # name, and that this practice of using the domain name option as
- # a search path is both nonstandard and deprecated.
- echo search $new_domain_name >> /etc/resolv.conf.dhclient
- fi
- for nameserver in $new_domain_name_servers; do
- echo nameserver $nameserver >>/etc/resolv.conf.dhclient
- done
-
- elif [ "x${new_dhcp6_name_servers}" != x ] ; then
- cat /dev/null > /etc/resolv.conf.dhclient6
- chmod 644 /etc/resolv.conf.dhclient6
-
- if [ "x${new_dhcp6_domain_search}" != x ] ; then
- echo search ${new_dhcp6_domain_search} >> /etc/resolv.conf.dhclient6
- fi
- for nameserver in ${new_dhcp6_name_servers} ; do
- echo nameserver ${nameserver} >> /etc/resolv.conf.dhclient6
- done
- fi
-
- # if both v4 and v6 clients are running, concatenate results
- cat /etc/resolv.conf.* > /etc/resolv.conf
-}
-
-# Must be used on exit. Invokes the local dhcp client exit hooks, if any.
-exit_with_hooks() {
- exit_status=$1
- if [ -f /etc/dhclient-exit-hooks ]; then
- . /etc/dhclient-exit-hooks
- fi
-# probably should do something with exit status of the local script
- exit $exit_status
-}
-
-# Invoke the local dhcp client enter hooks, if they exist.
-if [ -f /etc/dhclient-enter-hooks ]; then
- exit_status=0
- . /etc/dhclient-enter-hooks
- # allow the local script to abort processing of this state
- # local script must set exit_status variable to nonzero.
- if [ $exit_status -ne 0 ]; then
- exit $exit_status
- fi
-fi
-
-###
-### DHCPv4 Handlers
-###
-
-if [ x$new_broadcast_address != x ]; then
- new_broadcast_arg="broadcast $new_broadcast_address"
-fi
-if [ x$new_subnet_mask != x ]; then
- new_subnet_arg="netmask $new_subnet_mask"
-fi
-if [ x$alias_subnet_mask != x ]; then
- alias_subnet_arg="netmask $alias_subnet_mask"
-fi
-
-if [ x$reason = xMEDIUM ]; then
- # Linux doesn't do mediums (ok, ok, media).
- exit_with_hooks 0
-fi
-
-if [ x$reason = xPREINIT ]; then
- if [ x$alias_ip_address != x ]; then
- # Bring down alias interface. Its routes will disappear too.
- ifconfig $interface:0- 0.0.0.0
- fi
- ifconfig $interface 0.0.0.0 up
-
- # We need to give the kernel some time to get the interface up.
- sleep 1
-
- exit_with_hooks 0
-fi
-
-if [ x$reason = xARPCHECK ] || [ x$reason = xARPSEND ]; then
- exit_with_hooks 0
-fi
-
-if [ x$reason = xBOUND ] || [ x$reason = xRENEW ] || \
- [ x$reason = xREBIND ] || [ x$reason = xREBOOT ]; then
- current_hostname=`hostname`
- if [ x$current_hostname = x ] || \
- [ x$current_hostname = x$old_host_name ]; then
- if [ x$current_hostname = x ] || \
- [ x$new_host_name != x$old_host_name ]; then
- hostname $new_host_name
- fi
- fi
-
- if [ x$old_ip_address != x ] && [ x$alias_ip_address != x ] && \
- [ x$alias_ip_address != x$old_ip_address ]; then
- # Possible new alias. Remove old alias.
- ifconfig $interface:0- 0.0.0.0
- fi
- if [ x$old_ip_address != x ] && [ x$old_ip_address != x$new_ip_address ]; then
- # IP address changed. Bringing down the interface will delete all routes,
- # and clear the ARP cache.
- ifconfig $interface 0.0.0.0 down
-
- fi
- if [ x$old_ip_address = x ] || [ x$old_ip_address != x$new_ip_address ] || \
- [ x$reason = xBOUND ] || [ x$reason = xREBOOT ]; then
-
- ifconfig $interface $new_ip_address $new_subnet_arg \
- $new_broadcast_arg
- for router in $new_routers; do
- if [ "x$new_subnet_mask" = "x255.255.255.255" ] ; then
- route add -host $router dev $interface
- fi
- route add default gw $router
- done
- fi
- if [ x$new_ip_address != x$alias_ip_address ] && [ x$alias_ip_address != x ];
- then
- ifconfig $interface:0- 0.0.0.0
- ifconfig $interface:0 $alias_ip_address $alias_subnet_arg
- route add -host $alias_ip_address $interface:0
- fi
- make_resolv_conf
- exit_with_hooks 0
-fi
-
-if [ x$reason = xEXPIRE ] || [ x$reason = xFAIL ] || [ x$reason = xRELEASE ] \
- || [ x$reason = xSTOP ]; then
- if [ x$alias_ip_address != x ]; then
- # Turn off alias interface.
- ifconfig $interface:0- 0.0.0.0
- fi
- if [ x$old_ip_address != x ]; then
- # Shut down interface, which will delete routes and clear arp cache.
- ifconfig $interface 0.0.0.0 down
- fi
- if [ x$alias_ip_address != x ]; then
- ifconfig $interface:0 $alias_ip_address $alias_subnet_arg
- route add -host $alias_ip_address $interface:0
- fi
-
- # remove v4 dns configuration for this interface
- rm /etc/resolv.conf.dhclient
- cat /etc/resolv.conf.* > /etc/resolv.conf
-
- exit_with_hooks 0
-fi
-
-if [ x$reason = xTIMEOUT ]; then
- if [ x$alias_ip_address != x ]; then
- ifconfig $interface:0- 0.0.0.0
- fi
- ifconfig $interface $new_ip_address $new_subnet_arg \
- $new_broadcast_arg
- set $new_routers
- if ping -q -c 1 $1; then
- if [ x$new_ip_address != x$alias_ip_address ] && \
- [ x$alias_ip_address != x ]; then
- ifconfig $interface:0 $alias_ip_address $alias_subnet_arg
- route add -host $alias_ip_address dev $interface:0
- fi
- for router in $new_routers; do
- if [ "x$new_subnet_mask" = "x255.255.255.255" ] ; then
- route add -host $router dev $interface
- fi
- route add default gw $router
- done
- make_resolv_conf
- exit_with_hooks 0
- fi
- ifconfig $interface 0.0.0.0 down
- exit_with_hooks 1
-fi
-
-###
-### DHCPv6 Handlers
-###
-
-if [ x$reason = xPREINIT6 ]; then
- # Ensure interface is up.
- ifconfig ${interface} up
-
- # Remove any stale addresses from aborted clients.
- ip -f inet6 addr flush dev ${interface} scope global
-
- exit_with_hooks 0
-fi
-
-if [ x${old_ip6_prefix} != x ] || [ x${new_ip6_prefix} != x ] ; then
- echo Prefix ${reason} old=${old_ip6_prefix} new=${new_ip6_prefix}
-
- exit_with_hooks 0
-fi
-
-if [ x$reason = xBOUND6 ]; then
- if [ x${new_ip6_address} = x ] || [ x${new_ip6_prefixlen} = x ] ; then
- exit_with_hooks 2;
- fi
-
- ifconfig ${interface} add ${new_ip6_address}/${new_ip6_prefixlen}
-
- # Check for nameserver options.
- make_resolv_conf
-
-### <<
- # Set up softwire tunnel
- if [ x${new_dhcp6_softwire} != x ] ; then
- /etc/init.d/dhclient stop
- ifconfig ${interface} 0.0.0.0
- ip -6 tunnel add tun0 mode ipip6 \
- remote ${new_dhcp6_softwire} \
- local ${new_ip6_address} \
- dev ${interface} encaplimit none
- ip link set tun0 up
- ip route add default dev tun0
- fi
-### >>
-
- exit_with_hooks 0
-fi
-
-if [ x$reason = xRENEW6 ] || [ x$reason = xREBIND6 ]; then
- if [ x${new_ip6_address} = x ] || [ x${new_ip6_prefixlen} = x ] ; then
- exit_with_hooks 2;
- fi
-
- ifconfig ${interface} add ${new_ip6_address}/${new_ip6_prefixlen}
-
- # Make sure nothing has moved around on us.
-
- # Nameservers/domains/etc.
- if [ "x${new_dhcp6_name_servers}" != "x${old_dhcp6_name_servers}" ] ||
- [ "x${new_dhcp6_domain_search}" != "x${old_dhcp6_domain_search}" ] ; then
- make_resolv_conf
- fi
-
- exit_with_hooks 0
-fi
-
-if [ x$reason = xDEPREF6 ]; then
- if [ x${new_ip6_address} = x ] ; then
- exit_with_hooks 2;
- fi
-
- # Busybox ifconfig has no way to communicate this to the kernel, so ignore it
-
- exit_with_hooks 0
-fi
-
-if [ x$reason = xEXPIRE6 -o x$reason = xRELEASE6 -o x$reason = xSTOP6 ]; then
- if [ x${old_ip6_address} = x ] || [ x${old_ip6_prefixlen} = x ] ; then
- exit_with_hooks 2;
- fi
-
- ifconfig ${interface} del ${old_ip6_address}/${old_ip6_prefixlen}
-
- # remove v6 dns configuration for this interface
- rm /etc/resolv.conf.dhclient6
- cat /etc/resolv.conf.* > /etc/resolv.conf
-
-### <<
- # Tear down softwire tunnel
- if [ x${old_dhcp6_softwire} != x ] ; then
- ip link set tun0 down
- ip tunnel del tun0
- fi
-### >>
-
- exit_with_hooks 0
-fi
-
-exit_with_hooks 0
+++ /dev/null
-#!/bin/sh /etc/rc.common
-START=60
-
-lease_file=/var/dhclient.leases
-config_file=/etc/dhclient.conf
-pid_file=/var/run/dhclient.pid
-script_file=/usr/sbin/dhclient-script
-
-start() {
- echo Starting isc-dhclient
-
- /usr/sbin/dhclient -q -nw -cf $config_file -lf $lease_file -pf $pid_file -sf $script_file `/sbin/uci get network.wan.ifname`
-
- if [ $? -ne 0 ]; then
- echo " isc-dhclient failed to start"
- fi
-}
-
-stop() {
- echo Stopping isc-dhclient
- if [ -e $pid_file ]; then
- kill -9 `cat $pid_file`
-
- if [ $? -ne 0 ]; then
- echo " PID " `cat $pid_file` not found
- echo " Is the DHCP client running?"
- fi
-
- rm $pid_file
- else
- echo " $pid_file not found"
- fi
-}
+++ /dev/null
-option dhcp6.softwire code 54 = ip6-address;
-also request dhcp6.softwire;
+++ /dev/null
-#!/bin/sh /etc/rc.common
-START=60
-
-lease_file=/var/dhclient6.leases
-config_file=/etc/dhclient6.conf
-pid_file=/var/run/dhclient6.pid
-script_file=/usr/sbin/dhclient-script
-
-start() {
- echo Starting isc-dhclient
-
- /usr/sbin/dhclient -q -nw -6 -cf $config_file -lf $lease_file -pf $pid_file -sf $script_file `/sbin/uci get network.wan.ifname`
-
- if [ $? -ne 0 ]; then
- echo " isc-dhclient failed to start"
- fi
-}
-
-stop() {
- echo Stopping isc-dhclient
- if [ -e $pid_file ]; then
- kill -9 `cat $pid_file`
-
- if [ $? -ne 0 ]; then
- echo " PID " `cat $pid_file` not found
- echo " Is the DHCP client running?"
- fi
-
- rm $pid_file
- else
- echo " $pid_file not found"
- fi
-}
+++ /dev/null
-# dhcpd.conf
-
-authoritative;
-
-default-lease-time 3600;
-max-lease-time 86400;
-
-option domain-name-servers 192.168.1.1;
-
-subnet 192.168.1.0 netmask 255.255.255.0 {
- range 192.168.1.10 192.168.1.50;
- option routers 192.168.1.1;
-}
+++ /dev/null
-#!/bin/sh /etc/rc.common
-START=65
-
-lease_file=/var/dhcpd.leases
-config_file=/etc/dhcpd.conf
-pid_file=/var/run/dhcpd.pid
-
-start() {
- echo Starting isc-dhcpd
-
- if [ ! -e $lease_file ]; then
- echo " Creating $lease_file"
- touch $lease_file
- fi
-
- /usr/sbin/dhcpd -q -cf $config_file -lf $lease_file -pf $pid_file
-
- if [ $? -ne 0 ]; then
- echo " isc-dhcpd failed to start"
- fi
-}
-
-stop() {
- echo Stopping isc-dhcpd
- if [ -e $pid_file ]; then
- kill -9 `cat $pid_file`
-
- if [ $? -ne 0 ]; then
- echo " PID " `cat $pid_file` not found
- echo " Is the DHCP server running?"
- fi
-
- rm $pid_file
- else
- echo " $pid_file not found"
- fi
-}
+++ /dev/null
-# dhcpd6.conf
-
-authoritative;
-
-default-lease-time 3600;
-max-lease-time 86400;
-
-# Enable RFC 5007 support
-#allow leasequery;
-
-# Global definitions for name server address(es) and domain search list
-#option dhcp6.name-servers 3ffe:501:ffff:100:200:ff:fe00:3f3e;
-#option dhcp6.domain-search "test.example.com","example.com";
-
-# Set preference to 255 (maximum) in order to avoid waiting for
-# additional servers when there is only one
-#option dhcp6.preference 255;
-
-# Server side command to enable rapid-commit (2 packet exchange)
-#option dhcp6.rapid-commit;
-
-# The delay before information-request refresh
-# (minimum is 10 minutes, maximum one day, default is to not refresh)
-# (set to 6 hours)
-#option dhcp6.info-refresh-time 3600;
-
-subnet6 3ffe:501:ffff:101::/64 {
- # Use the whole /64 prefix for clients
- range6 3ffe:501:ffff:101:: /64;
-}
+++ /dev/null
-#!/bin/sh /etc/rc.common
-START=65
-
-lease_file=/var/dhcpd6.leases
-config_file=/etc/dhcpd6.conf
-pid_file=/var/run/dhcpd6.pid
-
-start() {
- echo Starting isc-dhcpd
-
- if [ ! -e $lease_file ]; then
- echo " Creating $lease_file"
- touch $lease_file
- fi
-
- /usr/sbin/dhcpd -q -6 -cf $config_file -lf $lease_file -pf $pid_file
-
- if [ $? -ne 0 ]; then
- echo " isc-dhcpd failed to start"
- fi
-}
-
-stop() {
- echo Stopping isc-dhcpd
- if [ -e $pid_file ]; then
- kill -9 `cat $pid_file`
-
- if [ $? -ne 0 ]; then
- echo " PID " `cat $pid_file` not found
- echo " Is the DHCP server running?"
- fi
-
- rm $pid_file
- else
- echo " $pid_file not found"
- fi
-}
+++ /dev/null
---- a/bind/Makefile 2011-11-28 23:08:15.000000000 +0000
-+++ b/bind/Makefile 2011-12-17 16:27:20.784433502 +0000
-@@ -49,13 +49,16 @@
-
- # Build the export libraries
- @echo Building BIND Export libraries - this takes some time.
-+ @(cd ${bindsrcdir}/lib/export/dns ; \
-+ echo building gen using ${BUILD_CC} in `pwd` ; \
-+ $(MAKE) CC=${BUILD_CC} CFLAGS="-O2" LIBS="" gen)
- @(cd ${bindsrcdir}/lib/export ; \
- echo building in `pwd` ; \
- MAKE=${GMAKE} ${GMAKE} > ${binddir}/build.log)
-
- @echo Installing BIND Export libraries to ${binddir}.
- @(cd ${bindsrcdir}/lib/export ; \
-- MAKE=${GMAKE} ${GMAKE} install > ${binddir}/install.log)
-+ $(MAKE) DESTDIR="" install > ${binddir}/install.log)
-
- clean:
- @echo Cleaning BIND export library.
-@@ -64,6 +67,7 @@
-
- # Include the following so that this Makefile is happy when the parent
- # tries to use them.
-+install-exec:
-
- distdir:
-